<template>
    <div class="container-fluid">
        <div class="row">
            <h1 class="font-weight-normal py-3 pl-3">{{title}}</h1>
        </div>
        <div class="row">
            <div class="col-md-10 offset-md-1 col-xs-12">
                <form @submit.prevent="onPublish(article.slug)">
                    <fieldset :disabled="inProgress">
                        <b-row>
                            <b-col md="6" sm="6">
                                <fieldset class="form-group">
                                    <label for="title">Title</label>
                                    <input
                                            type="text"
                                            class="form-control"
                                            name="title"
                                            id="title"
                                            v-model="article.title"
                                            placeholder="Title"
                                            v-validate="'required'"
                                            :class="{ 'is-invalid': submitted && errors.has('title') }" />
                                    <div v-if="submitted && errors.has('title')" class="invalid-feedback">{{ errors.first('title') }}</div>
                                </fieldset>
                                <fieldset class="form-group">
                                    <label for="description">Description</label>
                                    <input
                                            type="text"
                                            class="form-control"
                                            name="description"
                                            id="description"
                                            v-model="article.description"
                                            placeholder="Description"
                                            v-validate="'required'"
                                            :class="{ 'is-invalid': submitted && errors.has('description') }" />
                                    <div v-if="submitted && errors.has('description')" class="invalid-feedback">{{ errors.first('description') }}</div>
                                </fieldset>
                                <fieldset class="form-group">
                                    <label for="post-body">Body</label>
                                    <textarea
                                            id="post-body"
                                            class="form-control"
                                            rows="8"
                                            v-model="article.body"
                                    >
                                    </textarea>
                                </fieldset>
                            </b-col>
                            <b-col lg="4" md="6" sm="6">
                                <fieldset class="form-group">
                                    <label for="tag">Tags</label>
                                    <input
                                            type="text"
                                            class="form-control"
                                            id="tag"
                                            name="tag"
                                            placeholder="Enter tags"
                                            v-model="tagInput"
                                            @keypress.enter.prevent="addTag(tagInput)"
                                    />
                                    <div class="tag-list border mt-3 rounded">
                                        <b-form-checkbox-group
                                                id="flavors"
                                                v-model="selected"
                                                :options="allTags"
                                                name="selected"
                                                class="ml-4 mt-3"
                                                aria-label="Tag List"
                                                stacked
                                        ></b-form-checkbox-group>
                                    </div>
                                </fieldset>
                            </b-col>
                        </b-row>
                    </fieldset>
                    <button
                            :disabled="inProgress"
                            class="btn pull-xs-right btn-primary"
                            type="submit"
                    >
                        Submit
                    </button>
                </form>
            </div>
        </div>
    </div>
</template>

<script>
    import {mapGetters} from "vuex";
    import store from "@/store";
    import {
        ARTICLE_PUBLISH,
        ARTICLE_EDIT,
        FETCH_ARTICLE,
        ARTICLE_RESET_STATE,
        FETCH_TAGS
    } from "@/store/actions.type";

    export default {
        name: "ArticleEdit",
        components: {},
        props: {
            previousArticle: {
                type: Object,
                required: false,
                title: ''
            }
        },
        async beforeRouteUpdate(to, from, next) {
            await store.dispatch(ARTICLE_RESET_STATE);
            await store.dispatch(FETCH_TAGS);
            if (to.params.slug !== undefined) {
                await store.dispatch(
                    FETCH_ARTICLE,
                    to.params.slug,
                    to.params.previousArticle
                );
            }
            this.allTags = this.tags;
            this.selected = this.article.tagList.length ? this.article.tagList : [];
            return next();
        },
        async beforeRouteEnter(to, from, next) {
            await store.dispatch(ARTICLE_RESET_STATE);
            await store.dispatch(FETCH_TAGS);
            if (to.params.slug !== undefined) {
                await store.dispatch(
                    FETCH_ARTICLE,
                    to.params.slug,
                    to.params.previousArticle
                );
            }
            return next();
        },
        async beforeRouteLeave(to, from, next) {
            await store.dispatch(ARTICLE_RESET_STATE);
            next();
        },
        data() {
            return {
                tagInput: null,
                inProgress: false,
                selected: [],
                allTags: [],
                submitted: false,
                title: 'New Article'
            };
        },
        beforeMount() {
            this.selected = this.article.tagList;
            const tagsArray = [];
            new Set(this.tags.concat(this.selected)).forEach(tag => {
                tagsArray.push(tag);
            });
            tagsArray.sort();
            this.allTags = tagsArray;
        },
        created() {
            this.title = this.getFields(this.$route.meta);
        },
        watch: {
            '$route' (to) {
                this.title = this.getFields(to.meta);
                this.selected = this.article.tagList.length ? this.article.tagList : [];
                const tagsArray = [];
                new Set(this.tags.concat(this.selected)).forEach(tag => {
                    tagsArray.push(tag);
                });
                tagsArray.sort();
                this.allTags = tagsArray;
            }
        },
        computed: {
            ...mapGetters(["article", "tags"])
        },
        methods: {
            onPublish(slug) {
                this.submitted = true;
                this.$validator.validate().then(valid => {
                    if (valid) {
                        const article = this.article;
                        article.tagList = this.selected;
                        let action = slug ? ARTICLE_EDIT : ARTICLE_PUBLISH;
                        this.inProgress = true;
                        this.$store
                            .dispatch(action, article)
                            .then(() => {
                                this.inProgress = false;
                                this.$router.push({
                                    name: "articles",
                                });
                            })
                            .catch(() => {
                                this.inProgress = false;
                            });
                    }
                });
            },
            addTag(tag) {
                let allTags = this.allTags;
                if (!allTags.includes(tag)) {
                    allTags.push(tag);
                    allTags.sort();
                }
                this.allTags = allTags;
                if (!this.selected.includes(tag)) {
                    this.selected.push(tag);
                }
                this.tagInput = '';
            },
            getFields: (meta) => {
                return meta.title;
            }
        }
    };
</script>
<style>
    .tag-list {
        max-height: 325px;
        overflow-y: auto;
    }
</style>